/*
 * rssyslog
 * The beginnings of what is to grow into a major syslog-server
 * Copyright (C) 2005-2007 Rune Stre
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Rune Stre <rst@folesvaert.no>
 *  
 */

/*
 * decode_message.h
 * Header file for code to decoding messages into printable format.
 */


#ifndef rssyslog_decode_message_h
#define rssyslog_decode_message_h

#include "message.h"
#include "init_targets.h"

/*
 * Clears entire message and initializes fields not to be changed, 
 * that is, standard separator fields
 */
int init_message(const struct Config* c, struct Message* m);

/*
 * Resets parts of message that might be changed by decoding
 */
int reset_message(const struct Config* c, struct Message* m);

/*
 * Decodes a message found in m
 */
int decode_message(const struct Config* c, struct Message* m);

/*
 * Finalises decoding if it for some reason fails
 */
int decode_fail(struct Message* m, int ix);


/*
 * Mostly for internal use
 */
int decode_fac_name(int fac, struct iovec* dest);
int decode_sev_name(int sev, struct iovec* dest);


#endif /* rssyslog_decode_message_h */

