/*
 * rssyslog
 * The beginnings of what is to grow into a major syslog-server
 * Copyright (C) 2007 Rune Stre
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Rune Stre <rst@folesvaert.no>
 *  
 */

/*
 * logfile_writer.h
 * Header file for message log writer thread.
 */

#ifndef rssyslog_logfile_writer_h
#define rssyslog_logfile_writer_h

#include "msg_queue.h"
#include "init_targets.h"

struct WriterData
{
  struct MsgQueue* q;
  struct Config* c;
  int msg_counter;
  int bailout;
};





int writer_init( struct WriterData* d,
                 struct MsgQueue* q,
                 struct Config* c );

/* 
 * Returns 1 if a match is found, 0 otherwise
 */
int target_match_filter(struct Target* t, struct Message* m);

/* 
 * This returns a file descriptor for the desired logfile.
 * A new filename is calculated and the file is reopened if appropriate.
 */
int target_get_fd(struct Target* t, struct tm* date);

/* 
 * Returns 1 if message m matches filter f, 0 otherwise
 */
int msgfilter_match(struct MsgFilter* f, struct Message* m);



int write_message(struct Config* conf, struct Message* m);

int writer_thread(void* user_data);

#endif /* rssyslog_logfile_writer_h */
