/*
 * rssyslog
 * The beginnings of what is to grow into a major syslog-server
 * Copyright (C) 2005-2007 Rune Stre
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Rune Stre <rst@folesvaert.no>
 *  
 */

/*
 * receive_message.h
 * Header file for message receiving code.
 * This includes opening sockets and binding the port(s) and running the
 *  receiving thread
 */

#ifndef rssyslog_receive_message_h
#define rssyslog_receive_message_h

#include "msg_queue.h"
#include "message.h"

#include <sys/socket.h>


/* 
 * We only support IPv4 UDP now. 
 * Other protocols might be added later. 
 * This file takes that into acconut
 */


/* The listener thread needs some user data to work on */
struct ListenerData
{
  struct MsgQueue* q;
  const struct Config* c;
  int udp_sd;
  int msg_counter;
  int bailout;

};


int listener_init( struct ListenerData* l,
                   struct MsgQueue* q, 
                   const struct Config* c);

/* Cleans up. Listener thread must be stopped */
int listener_close( struct ListenerData* l);


/* The function doing the work */
int listener_thread(void* user_data);



int listener_receive_ipv4_udp(int sd, struct Message* m);


#endif /* rssyslog_receive_message_h */
