/*
 * rssyslog
 * The beginnings of what is to grow into a major syslog-server
 * Copyright (C) 2005-2007 Rune Stre
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Rune Stre <rst@folesvaert.no>
 *  
 */

/*
 * rssyslogd.h
 * The main header file. 
 */

#ifndef rssyslogd_h
#define rssyslogd_h

#include "init_targets.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <netdb.h>
#include <signal.h>

/* Configuration defines */
#define CFGFILE  "/etc/rssyslog.conf"

/* Fix this with configure some time */
#define RETSIGTYPE void

struct Message;

extern volatile sig_atomic_t quit_flag;

void warn(int err, char* str);
void fail(int err, char* str);

RETSIGTYPE sighandler_term(int sig);

int daemonize();



#endif /* rssyslogd_h */





